// NAVITUNE t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char buff[0x400*5*80];	// 1024byte x 5sector x 80track
static unsigned char dir[0x100*3];
static char dirpath[FILENAME_MAX];				// 쐬fBNg

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int diskno,numdisk,i,fn;
	int mode=1;
	int s_sec,e_sec,size;
	int trk,sec;
	int secnum=5;

	if (argc<2 && argc>4)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		fprintf(stderr, "       -d : not make sub directory\n");
		return 1;
	}

	if (argc==3 && !strcmp(argv[2],"-d"))
	{
		mode=0;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	numdisk = disk.GetNumDisk();	// fBXNC[W

	for (diskno=0; diskno<numdisk; diskno++)	// C[W̏
	{
		disk.SelectDisk(diskno);
		disk.SetRecordRange(0x01,0x10);
		// fBNg[h
		if (!disk.ReadDATA(0x00, 0x00, 0x00, 0x03, 0x01, dir, 0x300)) break;
		sprintf(dirpath,"%03d",diskno);		// fBNg̐
		if (mode)
		{
			_mkdir(dirpath);				// fBNg쐬
			_chdir(dirpath);				//
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		disk.SetRecordRange(0x01,0x05);

		for (fn=0; fn<(sizeof(dir)/0x10); fn++)
		{
			unsigned char *ent = &dir[fn*0x10];
			if (!memchr(ent,'\0',12)) continue;	// ȃGg̔
			if (*ent == 0xff) break;	// fBNg̍Ō
			int i;
			int fnp = 0;
			for (i=0x00; i<0x0c; i++)
			{
				char c = ent[i];		// t@CPo
				if (c=='\0') break;
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '\0';		// ̍Ō

			s_sec  = *(ent+0x0c)+*(ent+0x0d)*0x100;		// Jn_ZN^
			e_sec  = *(ent+0x0e)+*(ent+0x0f)*0x100;		// I_ZN^
			size = (e_sec-s_sec+1)*0x400;	// TCYvZ
			trk = s_sec/secnum;
			sec = s_sec%secnum+1;

			printf("%-11s  %02x %02x SIZE:%04x\n",fname,trk,sec,size);
			fcut(fname, trk, trk>>1, trk&1, sec, 0x03, 0x0000, size);
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}

